class PalgaEdit < Qt::LineEdit
  slots "showchange(const QString&)"
  
  @@all_fields = Hash.new
  
  def initialize(attr, w, n)
    super(w,n)
    begin
      @len = attr['leng'].to_i
      @len = 4 if @len == 0
      @rubid = attr['rnum'] || attr['id']
    rescue
      attr.each do |n, v|
        STDERR.puts "#{n}: #{v}"
      end
      raise
    end
    if @@all_fields.has_key?(@rubid)
      attr.each do |n, v|
        STDERR.puts "#{n}: #{v}"
      end
      @@all_fields.each do |n, v|
        STDERR.puts "#{n}: #{v}"
      end
#      puts attr.inspect
      raise "#{@rubid} komt twee keer voor"
    end
    @@all_fields[@rubid] = self
    setMaxLength(@len)
    setMaximumWidth((@len > 72 ? 72 : @len) * fontMetrics.width('w') + fontMetrics.width('  '))
    @widget = w
  end
  def showchange(txt)
    STDERR.puts "#{@rubid} #{@rubid.class} #{txt}"
    if @rubid == "4"
     STDERR.puts "bingo"
     @@all_fields.each_pair do |k,v|
        v.setText(k)
      end
    end
  end
  def focusInEvent(ev)
    STDERR.puts "focusin #{@rubid} #{self.class} #{self.parent.class} V:#{self.visible}"
    obj = self
    while !obj.nil?
      STDERR.puts("P: #{obj.class} #{obj.object_id}")
      obj = obj.parent
    end
    STDERR.puts "#{self.parent.object_id} #{$tabw.object_id}"
    STDERR.puts "#{width} -- #{height}"
    @before = @@all_fields[@rubid].text
#    Qt.debug_level = Qt::DebugLevel::High
    $tabw.showPage(@widget)
#    Qt.debug_level = Qt::DebugLevel::Off
    super
  end
#  def sizePolicy
#    rsl = super
#    STDERR.puts "sizePolicy: #{rsl}"
#    rsl
#  end
  def sizeHint
    rsl = super
#    STDERR.puts "sizeHint: #{name} #{rsl.width} #{rsl.height} #{fontMetrics.width('w' * @len)}"
#    puts b.fontMetrics.width('w')
    Qt::Size.new(fontMetrics.width('w' * @len), rsl.height)
  end
  def focusOutEvent(ev)
    @after = @@all_fields[@rubid].text
    STDERR.puts "focusout #{@rubid} #{@before} #{@after}"
    if @rubid == "4" && @before != @after 
      STDERR.puts "bingo"
      @@all_fields.each_pair do |k,v|
        v.setText( @after == 'clear' ? '' : k)
      end
      if @@all_fields.has_key?(@after)
        @@all_fields[@after].setFocus
      end
    end
    super
  end
end
